(** This module contains the function to be run when the module is
    loaded and also registers the strategies wrt WP plugin.

    @author Christophe Garion
    @author Lelio Brun
*)

(** Prints a message when the plugin is loaded. *)
let run () =
  Lustrec_wp_strategies_options.Self.result "LustreC WP strategies available."

(** Register strategies to WP and print simple message when used. *)
let () =
  Wp.Strategy.register (new Lustrec_wp_strategies_definitions.lustrec_transitions);
  Wp.Strategy.register (new Lustrec_wp_strategies_definitions.lustrec_memory_packs);
  Db.Main.extend run
