open Format
open Lustre_types
open Machine_code_types
open C_backend_common

module type MODIFIERS_HDR = sig
  module GhostProto : MODIFIERS_GHOST_PROTO

  val pp_is_contract : (formatter -> unit) -> formatter -> unit
  val pp_predicates : formatter -> machine_t list -> unit
  val pp_machine_decl_prefix : formatter -> machine_t -> unit
  val pp_import_arrow : formatter -> unit -> unit
  val pp_machine_alloc_decl : formatter -> machine_t -> unit
end

module EmptyMod : MODIFIERS_HDR

module Main (ModSrc : C_backend_src.MODIFIERS_SRC) (ModHdr : MODIFIERS_HDR) : sig
  val pp_header_from_header : formatter -> string -> top_decl list -> unit

  val pp_alloc_header :
    formatter -> string -> machine_t list -> dep_t list -> unit

  val pp_memory_header :
    formatter -> string -> machine_t list -> dep_t list -> unit

  val pp_spec_header :
    formatter -> string -> machine_t list -> dep_t list -> unit
end
