open Utils
open Format
open Lustre_types
open Machine_code_types

module type MODIFIERS_MAINSRC = sig
  val pp_import_spec_prototype : formatter -> dep_t -> unit

  val pp_declare_ghost_state :
    machine_t -> machine_t option -> formatter -> ident -> unit

  val pp_ghost_state_parameter :
    machine_t -> formatter -> machine_t option -> unit

  val pp_main_spec : formatter -> unit

  val pp_main_loop_invariants :
    ident -> machine_t list -> formatter -> machine_t -> unit

  val pp_main_loop_end :
    ident -> machine_t list -> formatter -> machine_t -> unit

  val pp_reset_contract : machine_t -> formatter -> machine_t -> unit
end

module EmptyMod : MODIFIERS_MAINSRC

module Main (Mod : MODIFIERS_MAINSRC) : sig
  val pp_main_c :
    formatter ->
    machine_t ->
    string ->
    program_t ->
    machine_t list ->
    dep_t list ->
    unit
end
